proc change_fmt {} {
global entree 
global f

regsub gif|pgm|ppm|tif|jpg|bmp $entree(result) $entree(format) entree(result)
}

proc Select_fichier {action} {
global entree
global f
 
set w .filebox
toplevel $w
wm title $w "File selection"
wm iconname $w "filebox"
 
label $w.msg -wraplength 4i -justify left -text "File name ?"
pack $w.msg -side top
 
frame $w.buttons
pack $w.buttons -side bottom -fill x -pady 2m
button $w.buttons.cancel -text "Cancel" -command {set entree(ok) 0}
button $w.buttons.ok -text "OK" -command {set entree(ok) 1}
pack $w.buttons.cancel $w.buttons.ok -side left -expand 1
 
   set f [frame $w.$action]
if {$action == "save"} {
    set entree(result) "no-title.gif" 
} else {
    set entree(result) ""
}
    label $f.lab -text "$action : " -anchor e
    entry $f.ent -width 20 -textvar entree(result)
    bind $f.ent <Return> {set entree(ok) 1}
    button $f.but -text "Search..." -command "fileDialog $w $f.ent $action"
    pack $f.lab -side left
    pack $f.ent -side left -expand yes -fill x
    pack $f.but -side left
    pack $f -fill x -padx 1c -pady 3
 
    checkbutton $w.strict -text "Look Motif" \
        -variable tk_strictMotif -onvalue 1 -offvalue 0
    pack $w.strict -anchor c
 if {$action == "save"} {
    set g [label $w.form_choice]
   label $g.texte -text "File type"
   radiobutton $g.gif -variable entree(format) -value "gif" -text "gif" -command "change_fmt"
   radiobutton $g.pgm -variable entree(format) -value "pgm" -text "pgm" -command "change_fmt"
   radiobutton $g.ppm -variable entree(format) -value "ppm" -text "ppm" -command "change_fmt"
   radiobutton $g.tiff -variable entree(format) -value "tif" -text "tiff" -command "change_fmt"
   radiobutton $g.jpg -variable entree(format) -value "jpg" -text "jpg" -command "change_fmt"
   radiobutton $g.bmp -variable entree(format) -value "bmp" -text "bmp" -command "change_fmt"
set entree(format) "gif"
pack $g.texte -in $w.form_choice -side top
pack $g.gif $g.pgm $g.ppm $g.tiff $g.jpg $g.bmp -in $w.form_choice -side left  
pack $g -side top
}
focus $f.ent
grab $w
tkwait variable entree(ok)
grab release $w
destroy $w
}     

proc fileDialog {w ent operation} {
global entree
    #   Type names              Extension(s)    Mac File Type(s)
    #
    #---------------------------------------------------------
 if {$operation == "save"} {
     set types {
         {"Image"   {.gif .pgm .ppm .tif .jpg .bmp}     }
         {"All files"           *}
     }
 set entree(result) [tk_getSaveFile -filetypes $types -parent $w \
 -initialfile "no-title" -defaultextension .$entree(format) -title "save"]
 } else {
     set types {
         {"Images gif"          {.gif}          }
         {"Images pgm"          {.pgm}          }
         {"Images ppm"          {.ppm}          }
         {"Images jpeg"         {.jpg .jpeg}            }
         {"Images tiff"         {.tif .tiff}            }
         {"Images bmp"          {.bmp}          }
         {"Other files"         *} 
 }
  set entree(result) [tk_getOpenFile -filetypes $types -parent $w \
                          -title $operation]
    }
}         

proc nouveau {} {
global nbimages
global image
global entree
global maj
 
    Select_fichier open
    if {$entree(ok)} {
	for {set i 0} {$i < $nbimages} {incr i} {
	    image create photo toto($i) -file $entree(result) -palette 256
	    Imgnew toto($i) $i
	    .cnv($i) configure \
		-width [expr [image width toto($i)]*$maj + 4] \
		-height [expr [image height toto($i)]*$maj + 4]
	    .cnv($i) create image [expr [image width toto($i)]/2 + 5] \
	        [expr [image height toto($i)]/2 + 5] -image toto($i) 
	    .cnv($i) configure -borderwidth 2 -relief ridge -bg red
	}
	update
	set image $entree(result)
    }
}      

proc save {} {
global entree
global p

Select_fichier save
    if {$entree(ok)} {
     set titi toto($p)
  switch $entree(format) {
    "ppm" {$titi write $entree(result) -format PPM/PGM}
    "pgm" {CMD save $p $entree(result)}
    "gif" {$titi write $entree(result) -format GIF}
    "tif" {$titi write $entree(result) -format TIFF}
    "bmp" {$titi write $entree(result) -format BMP}
    "jpg" {$titi write $entree(result) -format JPEG}
}
}
}

proc recup {} {
global p
global image

image create photo toto($p) -file $image -palette 256
Imgnew toto($p) $p
update
}


proc decrem {} {
global nbit
    set nbit [expr $nbit - 1]
    if {$nbit < 1} {
   set nbit 1
    }
}

proc increm {} {
global nbit
    incr nbit
    if {$nbit > 100} {
  set nbit 100
    }
}

proc dec10 {} {
global nbit
    decrem 
    while {[expr $nbit % 10] != 0} {set  nbit [expr $nbit - 1]}
    if {$nbit < 1} {set nbit 1}
}

proc inc10 {} {
global nbit
     increm
    while {[expr $nbit % 10] != 0} {incr nbit}
  if {$nbit > 100} {set nbit 100}
}

proc message {text} {

toplevel .msg
wm title .msg "Message"

label .msg.corps -wraplength 4i -justify left -text $text
pack .msg.corps -side top
 
button .msg.button -text "OK" -command {set message_lu 1}
pack .msg.button -side left -expand 1
 
grab .msg
tkwait variable message_lu
grab release .msg
destroy .msg

}

proc copy {} {
global p
global q

CMD copy $p $q
}

proc magnify {} {

global x1 
global y1
global x2 
global y2
global nx
global p
 
set petit toto($p)
set gros bigtoto($p)
image create photo $gros -height [expr $nx*($y2($p) - $y1($p))] \
                         -width [expr $nx*($x2($p) - $x1($p))] \
                         -palette 256                                       
$gros copy $petit -from $x1($p) $y1($p) $x2($p) $y2($p) -zoom $nx
set win .zo_$gros
if {[winfo exists $win]} {
    set titre "Zoom ($x1($p),$y1($p)) -> ($x2($p),$y2($p))"
    wm title $win $titre
} else {
toplevel $win
set titre "Zoom ($x1($p),$y1($p)) -> ($x2($p),$y2($p))"
wm title $win $titre
 
label $win.img -image $gros
pack $win.img -side top
 
button $win.button -text "Dismiss" -command "image delete $gros; \
                                            destroy $win"
pack $win.button -side left -expand 1
}                                      
}

proc debutfenetre {num x y} {

global x1 
global y1
global box_anchor
global box_last

# 4 = epaisseur de la bordure
set x1($num) [expr $x - 4] 
set y1($num) [expr $y - 4]
catch {.cnv($num) delete $box_last($num)}
set box_anchor($num) [list $x $y]
catch {unset box_last($num)}
}

proc dessinefenetre {num x y} {
global box_anchor
global box_last

catch {.cnv($num) delete $box_last($num)}
set box_last($num) [eval {.cnv($num) create rect} $box_anchor($num) \
			{$x $y -tag box -outline red}]
}

proc finfenetre {num x y} {

global x1 
global y1
global x2 
global y2

set x2($num) [expr $x - 4]
set y2($num) [expr $y - 4]

set xmax [expr [image width toto($num)] - 1]
set ymax [expr [image height toto($num)] - 1]
if {$x1($num) > $x2($num)} {set tp $x1($num)
                set x1($num) $x2($num)
                set x2($num) $tp}
if {$y1($num) > $y2($num)} {set tp $y1($num)
                set y1($num) $y2($num)
                set y2($num) $tp}
if {$x2($num) > $xmax} {set x2($num) $xmax}
if {$y2($num) > $ymax} {set y2($num) $ymax}
if {$x1($num) < 0} {set x1($num) 0} 
if {$y1($num) < 0} {set y1($num) 0} 
if {($x1($num) == $x2($num)) || ($y1($num) == $y2($num))} {
set x1($num) 0
set y1($num) 0
set x2($num) $xmax
set y2($num) $ymax
}
}

proc pub {} {

toplevel .pub
wm title .pub "Info Inti2.0"

image create photo logo -file ./.intilogo.gif -palette 256/256/256

label .pub.img -image logo
pack .pub.img -side top

button .pub.button -text "Fermer" -command {destroy .pub}
pack .pub.button -side left -expand 1

}
