#!/bin/sh
# \
exec ./intiwish "$0" "$@"
###############################################

#Mise a jour de la librairie TCL :
auto_mkindex ./LIBTCL *.tcl

lappend auto_path ./LIBTCL/

# Charge le package tkimg, si present
catch {package require Img}

set nbimages 2
set image ""
set maj 1

for {set i 0} {$i < $argc} {incr i} {
set str [lindex $argv $i]
     switch -- $str {
 	"-nb" {set nbimages [lindex $argv [expr $i +1]]}
 	"-i" {set image [lindex $argv [expr $i +1]]}
 	"-maj" {set maj [lindex $argv [expr $i +1]]}
     }
 }
 
Intinew CMD $nbimages 

label .planbin1
label .planbin2
set milieu [expr $nbimages/2]
for {set i 0} {$i < $nbimages} {incr i} {
image create photo toto($i) -file $image -palette 256
Imgnew toto($i) $i
canvas .cnv($i) -borderwidth 2 -relief ridge -bg red \
		-width [expr [image width toto($i)]*$maj + 4] \
                -height [expr [image height toto($i)]*$maj + 4]
.cnv($i) create image [expr [image width toto($i)]/2 + 5] \
	        [expr [image height toto($i)]/2 + 5] -image toto($i) 
set x1($i) 0 
set y1($i) 0
set x2($i) [expr [image width toto(0)] - 1] 
set y2($i) [expr [image height toto(0)] - 1]
bind .cnv($i) <Button-1> "debutfenetre $i %x %y"
bind .cnv($i) <B1-Motion> "dessinefenetre $i %x %y"
bind .cnv($i) <ButtonRelease-1> "finfenetre $i %x %y"
label .op($i)
radiobutton .op1($i) -variable p -value $i -text "1" -selectcolor red  
radiobutton .op2($i) -variable q -value $i -text "2" -selectcolor red
pack .op1($i) .op2($i) -in .op($i) -side left
    if {$i<$milieu} {
	pack .cnv($i) .op($i) -in .planbin1 -side top
    } else {
	pack .cnv($i) .op($i) -in .planbin2 -side top
    }
}

#update

set p 0
set q 1

set num 0
set nbit 1

label .act

label .menubar -relief sunken

menubutton .gene -text "File" -menu .gene.menu
set m [menu .gene.menu]
$m add command -label "Original" -command "recup"
$m add command -label "New image" -command "nouveau"
$m add command -label "Save image" -command "save"
$m add command -label "Quit" -command "exit"

menubutton .propag -text "Propagation" -menu .propag.menu
set m [menu .propag.menu]
$m add cascade -label "Distance Functions" -menu $m.sub1
set m1 [menu $m.sub1 -tearoff 0]
$m1 add command -label "d4" -command "fctdist d4"
$m1 add command -label "d8" -command "fctdist d8"
$m1 add command -label "chamfer 3-4" -command "fctdist ch3-4"
$m1 add command -label "chamfer 5-7-11" -command "fctdist ch5-7-11"
$m1 add command -label "chamfer 14-20-31-44" -command "fctdist ch14-20-31-44"
$m add cascade -label "Local Maxima" -menu $m.sub2
set m2 [menu $m.sub2 -tearoff 0]
$m2 add command -label "4-connectivity" -command "maxloc 4"
$m2 add command -label "8-connectivity" -command "maxloc 8"
$m add command -label "Local maxima (4-distance)" -command "mp 4"
$m add command -label "Local maxima (8-distance)" -command "mp 8"
$m add command -label "Mixed local maxima" -command "mp 48"
$m add separator
$m add cascade -label "Regional maxima" -menu $m.sub3
set m3 [menu $m.sub3 -tearoff 0]
$m3 add command -label "4-connectivity" -command "eroult 4"
$m3 add command -label "8-connectivity" -command "eroult 8"
$m add separator
$m add command -label "Geodesic reconstruction (4-cx)" -command "rec_geo 4"
$m add command -label "Geodesic reconstruction (8-cx)" -command "rec_geo 8"
$m add separator
$m add command -label "Pruning" -command "ebarbul"
$m add command -label "SKIZ" -command "skiz"

menubutton .thinning -text "Thinning (by step)" -menu .thinning.menu
set m [menu .thinning.menu]

$m add command -label "Skeleton with anchor set" -command "skaff"
$m add command -label "Jang et Chin skeleton" -command "jach"
$m add command -label "Stewart skeleton" -command "stew"
$m add command -label "Guo and Hall AFP1" -command "afp 1"
$m add command -label "Guo and Hall AFP2" -command "afp 2"
$m add command -label "Guo and Hall AFP3" -command "afp 3"
$m add command -label "Latecki skeleton" -command "latecki 1"
$m add command -label "Latecki modified skeleton" -command "latecki 2"
$m add separator
$m add command -label "MB1 skeleton" -command "mbfp mb1"
$m add command -label "MB2 skeleton" -command "mbfp mb2"
$m add command -label "MB2 minimal" -command "mbfp mb2min"
$m add command -label "MB homotopic kernel" -command "sk1p 4"
$m add separator
$m add command -label "MB1 directional 4-c" -command "mbdir mb1 4"
$m add command -label "MB2 directional 4-c" -command "mbdir mb2 4"
$m add separator
$m add command -label "MB1 directional 8-c" -command "mbdir mb1 8"
$m add command -label "MB2 directional 8-c" -command "mbdir mb2 8"
$m add separator
$m add command -label "MB1 hybride 4-c" -command "mbhybride mb1 4"
$m add command -label "MB2 hybride 4-c" -command "mbhybride mb2 4"
$m add separator
$m add command -label "MB1 hybride 8-c" -command "mbhybride mb1 8"
$m add command -label "MB2 hybride 8-c" -command "mbhybride mb2 8"

menubutton .opt -text "Options" -menu .opt.menu
set m [menu .opt.menu]
$m add cascade -label "Edge condition" -menu $m.sub1
set m1 [menu $m.sub1 -tearoff 0]
$m1 add radio -label "zero" -variable bord -value 0 -command "CMD change_bord 0" -selectcolor red
$m1 add radio -label "geodesic" -variable bord -value 1 -command "CMD change_bord 1" -selectcolor red
$m1 add radio -label "wrapped" -variable bord -value 2 -command "CMD change_bord 2" -selectcolor red
$m1 invoke 1
$m add cascade -label "Right angles detection" -menu $m.sub2
set m2 [menu $m.sub2 -tearoff 0]
$m2 add radio -label "Off" -variable cornerflag -value 0 -selectcolor red
$m2 add radio -label "On" -variable cornerflag -value 1 -selectcolor red
$m2 invoke 0
$m add command -label "About..." -command "pub"

pack .gene .propag .thinning .opt -in .menubar -side left

label .iterate -borderwidth 3 -bg blue -relief ridge -height 4 -width 28 
label .tit -text "Number of iterations"
place .tit -in .iterate -relx 0 -rely 0.5 -relheight 0.5 -relwidth 1
button .moinsun -command "decrem" -text "-"
place .moinsun -in .iterate -relx 0.2 -rely 0 -relheight 0.5 -relwidth 0.2
button .moins10 -command "dec10" -text "-10"
place .moins10 -in .iterate -relx 0 -rely 0 -relheight 0.5 -relwidth 0.2
button .resnbit -command "set nbit 1" -bg red -textvariable nbit
place .resnbit -in .iterate -relx 0.4 -rely 0 -relheight 0.5 -relwidth 0.2
button .plusun -command "increm" -text "+"
place .plusun -in .iterate -relx 0.6 -rely 0 -relheight 0.5 -relwidth 0.2
button .plus10 -command "inc10" -text "+10"
place .plus10 -in .iterate -relx 0.8 -rely 0 -relheight 0.5 -relwidth 0.2

label .zoom -borderwidth 3 -bg blue -relief ridge
button .zo -text "zoom x" -command "magnify"
set nx 2
scale .znb -from 2 -to 8 -variable nx -orient horizontal 
pack .zo .znb -in .zoom -side top -expand true -fill x

label .operations -borderwidth 3 -bg blue -relief ridge
button .cp -text "copy" -command "copy"
label .fbase1 -height 3 -width 28
button .b1 -text "Not" -command "com_base non"
button .b2 -text "And" -command "com_base et"
button .b3 -text "Or" -command "com_base ou"
pack .b1 .b2 .b3 -in .fbase1 -side left -expand true -fill x
label .fbase2 -height 3 -width 28
button .b4 -text "And not" -command "com_base diff"
button .b5 -text "Xor" -command "com_base xor"
pack .b4 .b5 -in .fbase2 -side left -expand true -fill x
pack .cp .fbase1 .fbase2 -in .operations -side top -expand true -fill x

label .mbthinning -borderwidth 3 -bg blue -relief ridge
label .title -relief ridge
label .tittitle -text "MB skeletons"
label .paramtitle
radiobutton .paramtitle(1) -variable mb -value 1 -text "MB1" -selectcolor red
radiobutton .paramtitle(2) -variable mb -value 2 -text "MB2" -selectcolor red
pack .paramtitle(1) .paramtitle(2) -in .paramtitle -side left
.paramtitle(2) invoke
pack .tittitle .paramtitle -in .title -side top -expand true -fill x
label .param1
label .connect -relief ridge
label .titcon -text "connect."
label .paramcon
radiobutton .connect(1) -variable cx -value 4 -text "4" -selectcolor red
radiobutton .connect(2) -variable cx -value 8 -text "8" -selectcolor red
pack .connect(1) .connect(2) -in .paramcon -side left
.connect(1) invoke
pack .titcon .paramcon -in .connect -side top -expand true -fill x
label .type -relief ridge
label .tittyp -text "type"
label .paramtyp 
radiobutton .type(1) -variable typ -value 1 -text "FP" -selectcolor red
radiobutton .type(2) -variable typ -value 2 -text "DIR" -selectcolor red
radiobutton .type(3) -variable typ -value 3 -text "HYB" -selectcolor red
pack .type(1) .type(2) .type(3) -in .paramtyp -side left
.type(1) invoke
pack .tittyp .paramtyp -in .type -side top -expand true -fill x
pack .connect .type -in .param1 -side left -expand true -fill x
label .param2 -relief ridge
label .tipparam2 -text "distance condition"
label .paramparam2_1
label .paramparam2_2
radiobutton .paramparam2(1) -variable dist -value 0 -text "none" -selectcolor red
radiobutton .paramparam2(2) -variable dist -value "d4" -text "d4" -selectcolor red
radiobutton .paramparam2(3) -variable dist -value "d8" -text "d8" -selectcolor red
radiobutton .paramparam2(4) -variable dist -value "ch3-4" -text "ch3/4" -selectcolor red
radiobutton .paramparam2(5) -variable dist -value "ch5-7-11" -text "ch5/11" -selectcolor red
radiobutton .paramparam2(6) -variable dist -value "ch14-20-31-44" -text "ch14/44" -selectcolor red
for {set k 1} {$k < 4} {incr k} {pack .paramparam2($k) -in .paramparam2_1 -side left}
for {set k 4} {$k < 7} {incr k} {pack .paramparam2($k) -in .paramparam2_2 -side left}
.paramparam2(1) invoke
pack .tipparam2 .paramparam2_1 .paramparam2_2 -in .param2 -side top -expand true -fill x
button .go -text "DO IT !" -bg orange -command "skmb"
pack .title .param1 .param2 .go -in .mbthinning -side top -expand true -fill x


pack .menubar -side top -expand true -fill x

pack .zoom .iterate .operations .mbthinning -in .act -side top -expand true -fill x

pack .planbin1 .planbin2 .act -side left
