#include "Image.hh"
#include "morfo.hh"
#include <string.h>
#include <stdio.h>
#include <math.h>

static int min(int a,int b) {if (a<b) return a; else return b;}
static int max(int a,int b) {if (a<b) return b; else return a;}

void Morpho_48(Image<int>& p,int erodil,int conex) {

  int index,valeur;
  Image<int> q(p);
  int* PIX=p.PI();
  int L=p.PL();
  int W=p.PW();

  if (conex == 4) {
    for (int j=0;j<L;j++)
      for (int i=0;i<W;i++) {
	index = j * W + i;
                 if (erodil == 0)
                 PIX[index]=min(PIX[index],min(q.X(i-1,j),min(q.X(i,j-1),min(q.X(i+1,j),q.X(i,j+1)))));
		 else  PIX[index]=max(PIX[index],max(q.X(i-1,j),max(q.X(i,j-1),max(q.X(i+1,j),q.X(i,j+1)))));}
  } else {
    for (int a=0;a<=1;a++)
      for (int b=-1;b<=1;b+=2) {
	for (int j=0;j<L;j++)
	  for (int i=0;i<W;i++) {
	    index = j * W + i;
	    if (erodil == 0)
	      PIX[index]=min(PIX[index],q.X(i-a*b,j-(1-a)*b));
	    else PIX[index]=max(PIX[index],q.X(i-a*b,j-(1-a)*b));
	  }
	q=p;
      }
  }
}
      
void Reconstruit_seq(Image<int>& p,Image<int>& p_ref,int cx){
 
int w = p.PW();
int h = p.PL();
int* PIX=p.PI();
Image<int> p_tamp(w,h);
int pas_fini = 1;
int Nb,index;
 
while (pas_fini) {
p_tamp = p; 
for (int j=0;j<h;j++)
  for (int i=0;i<w;i++){
    index = j * w + i;
    if (cx == 4) {PIX[index]=min(p_ref.X(i,j),max(PIX[index],max(p.X(i-1,j),p.X(i,j-1))));}
    else {PIX[index]=min(p_ref.X(i,j),max(PIX[index],max(p.X(i-1,j-1),max(p.X(i,j-1),p.X(i-1,j)))));}
  }
for (int j=h-1;j>=0;j--)
  for (int i=w-1;i>=0;i--){
    index = j * w + i;
    if (cx == 4) {PIX[index]=min(p_ref.X(i,j),max(PIX[index],max(p.X(i+1,j),p.X(i,j+1))));}
    else {PIX[index]=min(p_ref.X(i,j),max(PIX[index],max(p.X(i+1,j+1),max(p.X(i,j+1),p.X(i+1,j)))));}
  }
p_tamp = p.Image_diff(p_tamp);    
Nb = p_tamp.Image_compte_pixel();
pas_fini = (Nb != 0);
     }
  }      
  

void MaxPropag(Image<int>& p,int conex){

int w = p.PW();
int h = p.PL();
Image<int> q(p);
Image<int> qtemp(p);
Image<int> pres(p);
int* Qpix=qtemp.PI();
int* Ppix=pres.PI();
int index,x,y,interior;
FIFO f(w*h);
FIFO g(w*h);
 
 pres = p;
 for (int j=0;j<h;j++)
   for (int i=0;i<w;i++){
     index = j*w + i;
     if (p.X(i,j)) {
       interior = p.X(i-1,j)&&p.X(i+1,j)&&p.X(i,j-1)&&p.X(i,j+1);
       if (conex == 8) interior = interior &&
			 p.X(i-1,j-1)&&p.X(i-1,j+1)&&p.X(i+1,j-1)&&p.X(i+1,j+1);
       if (!interior) {f.FIFO_add(i,j); Qpix[index]=0;Ppix[index]=0;}
     }
   }

 while (!f.FIFO_empty()) { 
   q = qtemp;
   while (!f.FIFO_empty()) {
     f.FIFO_get(x,y);
     if (qtemp.X(x-1,y)) {g.FIFO_add(x-1,y);Qpix[y*w+x-1]=0;Ppix[y*w+x-1]=0;}
     if (qtemp.X(x+1,y)) {g.FIFO_add(x+1,y);Qpix[y*w+x+1]=0;Ppix[y*w+x+1]=0;}
     if (qtemp.X(x,y-1)) {g.FIFO_add(x,y-1);Qpix[(y-1)*w+x]=0;Ppix[(y-1)*w+x]=0;}
     if (qtemp.X(x,y+1)) {g.FIFO_add(x,y+1);Qpix[(y+1)*w+x]=0;Ppix[(y+1)*w+x]=0;}
     if (conex == 8) {
       if (qtemp.X(x-1,y-1)) {g.FIFO_add(x-1,y-1);Qpix[(y-1)*w+x-1]=0;Ppix[(y-1)*w+x-1]=0;}
       if (qtemp.X(x+1,y-1)) {g.FIFO_add(x+1,y-1);Qpix[(y-1)*w+x+1]=0;Ppix[(y-1)*w+x+1]=0;}
       if (qtemp.X(x-1,y+1)) {g.FIFO_add(x-1,y+1);Qpix[(y+1)*w+x-1]=0;Ppix[(y+1)*w+x-1]=0;}
       if (qtemp.X(x+1,y+1)) {g.FIFO_add(x+1,y+1);Qpix[(y+1)*w+x+1]=0;Ppix[(y+1)*w+x+1]=0;}
     }
     interior = q.X(x-1,y)||q.X(x+1,y)||q.X(x,y-1)||q.X(x,y+1);
     if (conex != 4) interior = interior ||
		       q.X(x-1,y-1)||q.X(x+1,y-1)||q.X(x-1,y+1)||q.X(x+1,y+1);
     if (!interior) Ppix[y*w+x]=255;
   }
   f = g;
   g.FIFO_delete();
 }
 p = pres;
}


void Reconstruit(Image<int>& p,Image<int>& p_ref,int cx){
 
int w = p.PW();
int h = p.PL();
int* PIX=p.PI();
int index,newi,newj,newindex,initial,x,y;
FIFO f(w*h);

Max_regionaux(p,cx);

if (cx == 4) { 
 for (int j=0;j<h;j++)
   for (int i=0;i<w;i++){
     index = j * w + i;
     if ((PIX[index]) && !(p.X(i-1,j) && p.X(i,j-1) && p.X(i+1,j) && p.X(i,j+1))) f.FIFO_add(i,j);
     }
 while (!f.FIFO_empty()) {
      f.FIFO_get(x,y);
      for (int a=0;a<=1;a++)
        for (int b=-1;b<=1;b+=2) {
              newi = x-a*b; newj = y-(1-a)*b;
              if ((p.X(newi,newj) < p.X(x,y)) && (p_ref.X(newi,newj) != p.X(newi,newj)) && (newi>=0) && (newj>=0) && (newi<w) && (newj<h)) {
                   newindex = newj * w + newi;
                   PIX[newindex] = min(p.X(x,y),p_ref.X(newi,newj));
                   f.FIFO_add(newi,newj);}
               }
       }
 }
else {
for (int j=0;j<h;j++)
  for (int i=0;i<w;i++){
    index = j * w + i;
    initial=1;
    for (int a=-1;a<=1;a++)
      for (int b=-1;b<=1;b++)
        initial = initial && p.X(i-a,j-b);
    if (PIX[index] && !initial) f.FIFO_add(i,j);
    }
while (!f.FIFO_empty()) {
           f.FIFO_get(x,y);
           for (int a=-1;a<=1;a++)
            for (int b=-1;b<=1;b++) {
              if ((a!=0)||(b!=0)) {
                 newi = x-a; newj = y-b;
                 if ((p.X(newi,newj) < p.X(x,y)) && (p_ref.X(newi,newj) != p.X(newi,newj)) && (newi>=0) && (newj>=0) && (newi<w) && (newj<h)) {
                       newindex = newj * w + newi;
                       PIX[newindex] = min(p.X(x,y),p_ref.X(newi,newj));
                       f.FIFO_add(newi,newj);}
	          }
	     }
	}   
 }   
}

void Max_regionaux(Image<int>& p,int cx){
 
int w = p.PW();
int h = p.PL();
int* PIX=p.PI();
Image<int> q(p);
int index,newi,newj,indexnew,x,y,maxloc,newindex;
FIFO f(w*h);
 
if (cx == 4) { 
for (int j=0;j<h;j++)
  for (int i=0;i<w;i++){
    index = j * w + i;
    if ((PIX[index] < max(q.X(i-1,j),max(q.X(i,j-1),max(q.X(i+1,j),q.X(i,j+1))))) && (q.X(i,j))) {PIX[index]=0;f.FIFO_add(i,j);}
    while (!f.FIFO_empty()) {
                            f.FIFO_get(x,y);
                            for (int a=0;a<=1;a++)
                              for (int b=-1;b<=1;b+=2) {
                                 newi = x-a*b; newj = y-(1-a)*b;
                                 if ((q.X(newi,newj) <= q.X(x,y)) && (newi>=0) && (newj>=0) && (newi<w) && (newj<h)) {
                                  newindex = newj * w + newi;
                                  if (PIX[newindex]) {
                                 PIX[newindex] = 0;f.FIFO_add(newi,newj);}
                                 }
	                          }
	                     }
     }
   }
else {
  for (int j=0;j<h;j++)
  for (int i=0;i<w;i++){
    index = j * w + i;
    maxloc=1;
    for (int a=-1;a<=1;a++)
      for (int b=-1;b<=1;b++)
        maxloc = maxloc && (PIX[index] >= q.X(i-a,j-b));
    if ((!maxloc) && (q.X(i,j))) {PIX[index]=0;f.FIFO_add(i,j);}
    while (!f.FIFO_empty()) {
                            f.FIFO_get(x,y);
                            for (int a=-1;a<=1;a++)
                              for (int b=-1;b<=1;b++) {
                                if ((a!=0)||(b!=0)) {
                                   newi = x-a; newj = y-b;
                                   if ((q.X(newi,newj) <= q.X(x,y)) && (newi>=0) && (newj>=0) && (newi<w) && (newj<h)) {
                                   newindex = newj * w + newi;
                                   if (PIX[newindex]) {
                                            PIX[newindex] = 0;
                                            f.FIFO_add(newi,newj);}
                                  }
	                        }
	                      }
	                   }   
     }
   }   
 }    	   

int PutDistance(Image<int>& p,int i,int j,char *nom,int sens) {
  if (sens == 1) {
    if (strcmp(nom,"d4")==0) return min(p.X(i-1,j),p.X(i,j-1))+1;
    if (strcmp(nom,"d8")==0) return min(p.X(i-1,j-1),min(p.X(i,j-1),min(p.X(i+1,j-1),p.X(i-1,j))))+1;
    if (strcmp(nom,"ch3-4")==0) return min(p.X(i-1,j-1)+4,min(p.X(i,j-1)+3,min(p.X(i+1,j-1)+4,p.X(i-1,j)+3)));
    if (strcmp(nom,"ch5-7-11")==0)
      return min(min(min(min(min(p.X(i-1,j),p.X(i,j-1))+5,
                             min(p.X(i-1,j-1),p.X(i+1,j-1))+7),
                         min(p.X(i-2,j),p.X(i,j-2))+10),
                     min(p.X(i-2,j-1),min(p.X(i-1,j-2),min(p.X(i+1,j-2),p.X(i+2,j-1))))+11),
                 min(p.X(i-2,j-2),p.X(i+2,j-2))+14);
    if (strcmp(nom,"ch14-20-31-44")==0) 
      return min(min(min(min(min(min(min(min(min(p.X(i-1,j),p.X(i,j-1))+14,
					     min(p.X(i-1,j-1),p.X(i+1,j-1))+20),
					 min(p.X(i-2,j),p.X(i,j-2))+28),
				     min(p.X(i-2,j-1),min(p.X(i-1,j-2),min(p.X(i+1,j-2),p.X(i+2,j-1))))+31),
				 min(p.X(i-2,j-2),p.X(i+2,j-2))+40),
			     min(p.X(i,j-3),p.X(i-3,j))+42),
			 min(p.X(i-3,j-1),min(p.X(i-1,j-3),min(p.X(i+1,j-3),p.X(i+3,j-1))))+44),
		     min(p.X(i-3,j-2),min(p.X(i-2,j-3),min(p.X(i+2,j-3),p.X(i+3,j-2))))+51),
		 min(p.X(i-3,j-3),p.X(i+3,j-3))+60);
  } else {
    if (strcmp(nom,"d4")==0) return min(p.X(i,j),(min(p.X(i+1,j),p.X(i,j+1))+1));
    if (strcmp(nom,"d8")==0) return min(p.X(i,j),min(p.X(i+1,j+1),min(p.X(i,j+1),min(p.X(i-1,j+1),p.X(i+1,j))))+1);
    if (strcmp(nom,"ch3-4")==0) return min(p.X(i,j),min(p.X(i+1,j+1)+4,min(p.X(i,j+1)+3,min(p.X(i-1,j+1)+4,p.X(i+1,j)+3))));
    if (strcmp(nom,"ch5-7-11")==0)
      return min(p.X(i,j),min(min(min(min(min(p.X(i+1,j),p.X(i,j+1))+5,
                                          min(p.X(i+1,j+1),p.X(i-1,j+1))+7),
                                      min(p.X(i+2,j),p.X(i,j+2))+10),
                                  min(p.X(i+2,j+1),min(p.X(i+1,j+2),min(p.X(i-1,j+2),p.X(i-2,j+1))))+11),
                              min(p.X(i+2,j+2),p.X(i-2,j+2))+14));
    if (strcmp(nom,"ch14-20-31-44")==0) 
      return min(p.X(i,j),min(min(min(min(min(min(min(min(min(p.X(i+1,j),p.X(i,j+1))+14,
							  min(p.X(i+1,j+1),p.X(i-1,j+1))+20),
						      min(p.X(i+2,j),p.X(i,j+2))+28),
						  min(p.X(i+2,j+1),min(p.X(i+1,j+2),min(p.X(i-1,j+2),p.X(i-2,j+1))))+31),
					      min(p.X(i+2,j+2),p.X(i-2,j+2))+40),
					  min(p.X(i,j+3),p.X(i+3,j))+42),
				      min(p.X(i+3,j+1),min(p.X(i+1,j+3),min(p.X(i-1,j+3),p.X(i-3,j+1))))+44),
				  min(p.X(i+3,j+2),min(p.X(i+2,j+3),min(p.X(i-2,j+3),p.X(i-3,j+2))))+51),
			      min(p.X(i+3,j+3),p.X(i-3,j+3))+60));
  }
}
 
void FctDistance(Image<int>& p,char *nom) {
  int h=p.PL();
  int w=p.PW();
  int i,j;
  int index = 0;
  int *PIX = p.PI();
  int valmax = 0;
 
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (*PIX > 0) *PIX = PutDistance(p,i,j,nom,1);
      PIX++;
        }             
  for (j=h-1;j>=0;j--)  
    for (i=w-1;i>=0;i--) { 
      PIX--;
      if (*PIX > 0) { 
        *PIX =  PutDistance(p,i,j,nom,-1); 
        if (*PIX > valmax) valmax = *PIX; 
         }
       }  
  // Affichage : rglage de la dynamique
  for (j=0;j<h;j++)
    for (i=0;i<w;i++) {
      if (*PIX > 0) *PIX = (*PIX * 255)/valmax;
      PIX++;
       }
} 

// void FctDistance(Image<int>& p,char *nom) {
//   int h=p.PL();
//   int w=p.PW();
//   int i,j;
//   int *PIX = p.PI();
//   int valmax = 0;
//   int index = 0;
 
//   for (j=0;j<h;j++)
//     for (i=0;i<w;i++) {
//       if (PIX[index]>0) PIX[index]= PutDistance(p,i,j,nom,1);
//       index++;
//     }
//   for (j=h-1;j>=0;j--)  
//     for (i=w-1;i>=0;i--) { 
//       index--;
//       if (PIX[index] > 0) { 
//         PIX[index] =  PutDistance(p,i,j,nom,-1); 
//         if (PIX[index] > valmax) valmax = PIX[index]; 
//          } 
//        }  
//   // Affichage : rglage de la dynamique
//   for (j=0;j<h;j++)
//     for (i=0;i<w;i++) {
//       if (PIX[index] > 0) PIX[index] = (PIX[index] * 255)/valmax;
//       index++;
//     }

// } 


void Maxlocaux(Image<int>& p,int conex) {
  int h=p.PL();
  int w=p.PW();
  int i,j,a,b,maxloc;
  Image<int> p_res(w,h);
  int *PIX = p_res.PI();
 
  if (conex == 4) {
    for (j=0;j<h;j++)
      for (i=0;i<w;i++)
	if (p.X(i,j) && (p.X(i,j)>=max(p.X(i-1,j),max(p.X(i,j-1),max(p.X(i+1,j),p.X(i,j+1)))))) PIX[j*w+i] = 255; else PIX[j*w+i] = 0;
  } else {
    for (j=0;j<h;j++)
      for (i=0;i<w;i++) {
	maxloc = p.X(i,j);
	for (a=-1;a<=1;a++)
	  for (b=-1;b<=1;b++)
	    maxloc = maxloc && (p.X(i,j) >= p.X(i-a,j-b));
	if (maxloc) PIX[j*w+i] = 255; else PIX[j*w+i] = 0;
      }
  }
  p = p_res;
} 

 void Ero_ult(Image<int>& p,int conex) {
   int h=p.PL();
   int w=p.PW();
   int i,j;
   int *PIX = p.PI();
   int index = 0;
   
   if (conex == 4)
     FctDistance(p,"d4");
   else 
     FctDistance(p,"d8");
   Max_regionaux(p,conex);
   for (j=0;j<h;j++)
     for (i=0;i<w;i++) {
       if (PIX[index] > 0) PIX[index] = 255;
       index++;
     }
 }
