#include "Image.hh"
#include "propagation.hh"

void point_simple(Image<int>& p,Image<int>& pres){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);
Image<int> p4(w,h);
Image<int> p5(w,h);

p1 = p | p.Est();
p3 = p1.Nord() - p.Est();
p1 = p1.SW() - p.Ouest();
p2 = p3 & p1;              // p2 : #transitions >= 2
p3 = p3 | p1;              // p3 : #transitions >= 1

p1 = p | p.Nord();
p5 = p1.Ouest() - p.Nord();
p4 = p3 & p5;
p2 = p2 | p4;
p3 = p3 | p5;
p5 = p1.SE() - p.Sud();
p4 = p3 & p5;
p2 = p2 | p4;
p3 = p3 | p5;

pres = p3 - p2;
}

void cross_number(Image<int>& p,Image<int>& pres){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);
Image<int> p4(w,h);

 p1 = p - p.Ouest();
 p2 = p1.Nord() & p1.NE(); // p2 : #transitions >= 2
 p3 = p1.Nord() | p1.NE(); // p3 : #transitions >= 1

 p1 = p - p.Nord();
 p4 = p3 & p1.Est(); p2 = p2 | p4; p3 = p3 | p1.Est();
 p4 = p3 & p1.SE(); p2 = p2 | p4; p3 = p3 | p1.SE();

 p1 = p - p.Est();
 p4 = p3 & p1.Sud(); p2 = p2 | p4; p3 = p3 | p1.Sud();
 p4 = p3 & p1.SW(); p2 = p2 | p4; p3 = p3 | p1.SW();

 p1 = p - p.Sud();
 p4 = p3 & p1.Ouest(); p2 = p2 | p4; p3 = p3 | p1.Ouest();
 p4 = p3 & p1.NW(); p2 = p2 | p4; p3 = p3 | p1.NW();

 p3 = p3 - p2;
 p2 = p & p.Ouest() & p.Nord() & p.Est() & p.Sud();

pres = p3 - p2;
}

void vp3ouplus(Image<int>& p,Image<int>& pres){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);

 p1 = p.Est() | p.NE();   // p1 : #voisins >= 1
 p2 = p.Est() & p.NE();   // p2 : #voisins >= 2
 p3 = p2 & p.Nord();      // p3 : #voisins >=3
 p2 = p2 | (p1 & p.Nord()); p1 = p1 | p.Nord();
 p3 = p3 | (p2 & p.NW());
 p2 = p2 | (p1 & p.NW()); p1 = p1 | p.NW();
 p3 = p3 | (p2 & p.Ouest());
 p2 = p2 | (p1 & p.Ouest()); p1 = p1 | p.Ouest();
 p3 = p3 | (p2 & p.SW());
 p2 = p2 | (p1 & p.SW()); p1 = p1 | p.SW();
 p3 = p3 | (p2 & p.Sud());
 p2 = p2 | (p1 & p.Sud()); p1 = p1 | p.Sud(); 
 p3 = p3 | (p2 & p.SE());

pres = p3;
}

 
void maxpropag(Image<int>& p,int conex){

int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);

int pas_fini = 1;
int compt = 0;
int Nb;

while (pas_fini) {
 if ((conex == 4)||(conex == 48)) {
p1 = p.Nord() & p.Est();
p1 = p1 & p1.SW();
p1 = p & p1;
  } else {
p1 = p & p.Nord();
p1 = p1 & p1.Est();
p1 = p1 & p1.Sud();
p1 = p1 & p1.Ouest();
  }
  if ((conex == 8)||(conex == 48)) {
p2 = p1 | p1.Nord();
p2 = p2 | p2.Est();
p2 = p2 | p2.Sud();
p2 = p2 | p2.Ouest();
  } else {
p2 = p1.Nord() | p1.Est();
p2 = p2 | p2.SW();
p2 = p1 | p2;
  }
p2 = p - p2;

if (compt%3 == 2) {
      Nb = p2.Image_compte_pixel();
      pas_fini = (Nb != 0);}
if (pas_fini) if (compt++ == 0) p3 = p2; else p3 = p3 | p2;
p = p1;
}
p = p3;
  }

 void front_nord(Image<int>& p){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> pe(w,h);
Image<int> ps(w,h);
Image<int> pw(w,h);
Image<int> pn(w,h);

pn = p.Nord();
pe = p.Est();
pw = p.Ouest();
ps = p.Sud();
p1 = (p.NW() - pw - pn) | 
     (p.NE() - pe - pn) |
     (p.SW() - pw - ps) |
     (p.SE() - pe - ps);
p2 = pw & pe - pn - ps;

p = p & (p1 | p2 | pn);
}

 void front_sud(Image<int>& p){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> pe(w,h);
Image<int> ps(w,h);
Image<int> pw(w,h);
Image<int> pn(w,h);

ps = p.Sud();
pn = p.Nord();
pe = p.Est();
pw = p.Ouest();
p1 = (p.NW() - pw - pn) | 
     (p.NE() - pe - pn) |
     (p.SW() - pw - ps) |
     (p.SE() - pe - ps);
p2 = pw & pe - pn - ps;

p = p & (p1 | p2 | ps);

}

 void front_ouest(Image<int>& p){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> pe(w,h);
Image<int> ps(w,h);
Image<int> pw(w,h);
Image<int> pn(w,h);

pw = p.Ouest();
ps = p.Sud();
pn = p.Nord();
pe = p.Est();
p1 = (p.NW() - pw - pn) | 
     (p.NE() - pe - pn) |
     (p.SW() - pw - ps) |
     (p.SE() - pe - ps);
p2 = pn & ps - pw - pe;

p = p & (p1 | p2 | pw);

}

void front_est(Image<int>& p){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> pe(w,h);
Image<int> ps(w,h);
Image<int> pw(w,h);
Image<int> pn(w,h);


pe = p.Est();
pw = p.Ouest();
ps = p.Sud();
pn = p.Nord();
p1 = (p.NW() - pw - pn) | 
     (p.NE() - pe - pn) |
     (p.SW() - pw - ps) |
     (p.SE() - pe - ps);
p2 = pn & ps - pw - pe;

p = p & (p1 | p2 | pe);

}

void sqaff(Image<int>& p,Image<int> p_ancr,int a){
int w = p.PW();
int h = p.PL();
Image<int> p_tamp(w,h);
 
   p_tamp = p;
    switch (a%8){
    case 0 : {front_nord(p);break;} 
    case 1 : {front_est(p);break;}
    case 2 : {front_sud(p);break;}
    case 3 : {front_ouest(p);break;}
    case 4 : {front_ouest(p);break;}
    case 5 : {front_sud(p);break;}
    case 6 : {front_est(p);break;}
    case 7 : {front_nord(p);break;}
    }
    p = p | p_ancr;
  
}


void edge(Image<int>& p) {

p = p & ((p.Ouest() - p.Est()) & (((p.NW() & p.SW()) & ((p.Nord() - p.NE()) & (p.Sud() - p.SE()))) | (p.Sud() - (p.Nord() | p.NE()))) |
         (p.Nord() - p.Sud()) & (((p.NW() & p.NE()) & ((p.Est() - p.SE()) & (p.Ouest() - p.SW()))) | (p.Ouest() - (p.Est() | p.SE()))) |
         (p.Est() - p.Ouest()) & (((p.NE() & p.SE()) & ((p.Sud() - p.SW()) & (p.Nord() - p.NW()))) | (p.Nord() - (p.Sud() | p.SW()))) |
         (p.Sud() - p.Nord()) & (((p.SW() & p.SE()) & ((p.Ouest() - p.NW()) & (p.Est() - p.NE()))) | (p.Est() - (p.Ouest() | p.NW()))));
}

void stewart(Image<int>& p) {
int w = p.PW();
int h = p.PL();
Image<int> pedge(w,h);

pedge = p;
edge(pedge);
p = p & ( !pedge | (pedge.Est() & p.Nord() & p.Sud())
              | (pedge.Sud() & p.Ouest() & p.Est())
              | (p.Sud() & p.Est() & (pedge.Sud() | pedge.Est()) - p.SE())
              | (p.Sud() & p.Ouest() & (pedge.Sud() | pedge.Ouest()) - p.SW())
              | (pedge.Est() & pedge.Sud() & pedge.SE()));
}


void jangchin(Image<int>& p, int dir){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);

 if (dir%4 == 0) {
 p1 = p.Est() - p.Ouest();
 p3 = p.Nord() | p.Sud();
 p2 = p1 & p3 & (p.Nord() | !p.NW()) & (p.Sud() | !p.SW());
  } else if (dir%4 == 2) {
 p1 = p.Ouest() - p.Est();
 p3 = p.Nord() | p.Sud();
 p2 = p1 & p3 & (p.Nord() | !p.NE()) & (p.Sud() | !p.SE());
  } else if (dir%4 == 1) {
 p1 = p.Sud() - p.Nord();
 p3 = p.Est() | p.Ouest();
 p2 = p1 & p3 & (p.Est() | !p.NE()) & (p.Ouest() | !p.NW());
  } else {
 p1 = p.Nord() - p.Sud();
 p3 = p.Est() | p.Ouest();
 p2 = p1 & p3 & (p.Est() | !p.SE()) & (p.Ouest() | !p.SW());
  }

p = p - p2;
}

void guohall(Image<int>& p,int type){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);
Image<int> p4(w,h);
Image<int> p5(w,h);

cross_number(p,p1);
vp3ouplus(p,p2);
p3 = p & p.SW();
p3 = p3.Nord() & p3.Est();
 if (type == 1) { 
  p5 = p | p.Nord() | p.Sud();
  p4 = ((p.Sud() - p.Nord() - p.Image_translat(Vecteur(0,-2)))
         & p5.Est() & p5.Ouest())
    | (p.Ouest() - p.Est() - p.Image_translat(Vecteur(2,0)));}
 else {
  p5 = p.Ouest() & p.Sud() & p.SW();
  p4 = p5 & 
   ((p.Ouest() & p.SE() - p.Nord() - p.Image_translat(Vecteur(0,-2)))
  | (p.Nord() & p.NW() - p.Est() - p.Image_translat(Vecteur(2,0)))
  | !(p.Image_translat(Vecteur(2,0)) | p.Image_translat(Vecteur(0,-2))
       | p.NW() | p.Nord() | p.NE() | p.Est() | p.SE()));
 }
p = p - (p1 & p2 - p3 - p4);
if (type == 3)
  {p5 = p.Sud() - p.Ouest();
   p3 = p5 & ((p.Ouest() - p.Est() - p.SW() - p.NE())
            | (p.Est() - p.Ouest() - p.SE() - p.NW()));
   p = p - p3;
  }
}

void latecki(Image<int>& p,int type){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);
Image<int> p4(w,h);
  // Marquage des points parfaits (sur p1)
p2 = p.Nord() & p.Est();
p2 = p2 & p2.SW() & p;
p1 = ((p2.Sud() - p.Nord())
    | (p2.Nord() - p.Sud())
    | (p2.Est() - p.Ouest())
    | (p2.Ouest() - p.Est()));
 if (type == 2) {
   p3 = p | p.SE();
   p1 = p1 | (p2.SW() - p3.Nord()) | (p2.NE() - p3.Ouest());
   p3 = p | p.SW();
   p1 = p1 | (p2.NW() - p3.Est()) | (p2.SE() - p3.Nord());
 }
 // Repere de la config critique au sud
p2 = p - p1;
p3 = p1 & p2.Sud();
p4 = p2 & p1.Sud();
p3 = p3 & (p4.Ouest() | p4.Est());
   // Retrait des points parfaits et pas critique au sud
 p = p2 | p3; 
}
  
void homototo(Image<int>& p,int type){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);
Image<int> p4(w,h);

 if (type == 0) {point_simple(p,p3); p = p - p3;}
 else {
   // calcul des "vrais contours"
   if (type != 2) {
p2 = p.Nord() & p.Est();
p2 = p2 & p2.SW() & p;
p3 = ((p2.Sud() - p.Nord())
    | (p2.Nord() - p.Sud())
    | (p2.Est() - p.Ouest())
    | (p2.Ouest() - p.Est()));
   }
   if (type != 1) {
 p1 = p | p.SE();
 p4 = (p2.SW() - p1.Nord()) | (p2.NE() - p1.Ouest());
 p1 = p | p.SW();
 p4 = p4 | (p2.NW() - p1.Est()) | (p2.SE() - p1.Nord());
 }
 if (type == 3) {
   p3 = p3 | p4;
}
 if (type == 2) {
 p3 = p4;
 }
   // simplicite restreinte
 p1 = p ^ p.Est();
 p1 = p1 & p1.Nord() & (p ^ p.Nord());
 p1 = p1 | p1.Ouest();
 p1 = p1 | p1.Sud();
 p = p - (p3 - p1);
 if (type == 4) {
    // retrait des extremites de courbes
 p1 = p | p.Nord() | p.Sud();
 p3 = p | p.Est() | p.Ouest();
 p2 = p & ((p1.Est() & p1.Ouest()) | (p3.Nord() & p3.Sud()));
    // reconstruction des petites CC
 p1 = p2 | p2.Nord();p1 = p1 | p1.Est();
 p1 = p1 | p1.Sud(); p1 = p1 | p1.Ouest();
 
 p1 = p - p1;

 p = p2 | p1;
  }
 }
}

void mb_directionnel(Image<int>& p){
  int w = p.PW();
  int h = p.PL();
  Image<int> pp(p);
  int index=0; 
  int* pix=p.PI();
  int alpha,beta;

  // Itration NORD
  for (int y=0;y<h;y++)
    for (int x=0;x<w;x++){
      if (pp.X(x,y) && !(pp.X(x,y-1))) {
	alpha = (pp.X(x-1,y+1)&&pp.X(x,y+1)&&pp.X(x+1,y+1)&&pp.X(x,y+2));
	beta = ((pp.X(x-1,y-1) && !(pp.X(x-1,y))) ||
		(pp.X(x+1,y-1) && !(pp.X(x+1,y))));
	if (alpha && !beta) pix[index]=0;
      }
      index++;
    }
  index=0; 
  pp = p;
  // Itration EST
  for (int y=0;y<h;y++)
    for (int x=0;x<w;x++){
      if (pp.X(x,y) && !(pp.X(x+1,y))) {
	alpha = (pp.X(x-1,y-1)&&pp.X(x-1,y)&&pp.X(x-1,y+1)&&pp.X(x-2,y));
	beta = ((pp.X(x+1,y-1) && !(pp.X(x,y-1))) ||
		(pp.X(x+1,y+1) && !(pp.X(x,y+1))));
	if (alpha && !beta) pix[index]=0;
      }
      index++;
    }
  index=0; 
  pp = p;
   // Itration SUD
  for (int y=0;y<h;y++)
    for (int x=0;x<w;x++){
      if (pp.X(x,y) && !(pp.X(x,y+1))) {
	alpha = (pp.X(x-1,y-1)&&pp.X(x,y-1)&&pp.X(x+1,y-1)&&pp.X(x,y-2));
	beta = ((pp.X(x-1,y+1) && !(pp.X(x-1,y))) ||
		(pp.X(x+1,y+1) && !(pp.X(x+1,y))));
	if (alpha && !beta) pix[index]=0;
      }
      index++;
    }
  index=0; 
  pp = p;
  // Itration OUEST
  for (int y=0;y<h;y++)
    for (int x=0;x<w;x++){
      if (pp.X(x,y) && !(pp.X(x-1,y))) {
	alpha = (pp.X(x+1,y-1)&&pp.X(x+1,y)&&pp.X(x+1,y+1)&&pp.X(x+2,y));
	beta = ((pp.X(x-1,y-1) && !(pp.X(x,y-1))) ||
		(pp.X(x-1,y+1) && !(pp.X(x,y+1))));
	if (alpha && !beta) pix[index]=0;
      }
      index++;
    }
}

void ebarbule(Image<int>& p){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);


   p1 = !(p.NW() | p.Nord() | p.NE() | p.Est() | p.Ouest());
   p2 = p.Sud() | (p.SW() ^ p.SE());
   p3 = p & p1 & p2;
   p1 = !(p.SW() | p.Sud() | p.SE() | p.Est() | p.Ouest());
   p2 = p.Nord() | (p.NW() ^ p.NE());
   p3 = p3 | (p & p1 & p2);
   p1 = p - p.Nord() - p.Sud();
   p2 = (p.Est() - p.NW() - p.Ouest() - p.SW())
      | (p.Ouest() - p.NE() - p.Est() - p.SE());
   p3 = p3 | (p1 & p2);
   p = p - p3;
   
}


void pare_chocs4(Image<int>& p,Image<int> p_cx,int dir)
 {
 int w = p.PW();
 int h = p.PL();
 Image<int> p1(w,h);
 Image<int> p2(w,h);
 Image<int> c(w,h);

 c = !p_cx;
   switch (dir) {
   case 0 : {p1 = p_cx.Est() & c;
             p = p1 & (p_cx.Ouest()
                    | (p_cx.NW() - p_cx.Nord())
                    | (p_cx.SW() - p_cx.Sud()));
   break;}
   case 2 : {p1 = p_cx.Ouest() & c;
             p = p1 & (p_cx.Est()
                    | (p_cx.NE() - p_cx.Nord())
                    | (p_cx.SE() - p_cx.Sud()));
   break;}
   case 3 : {p1 = p_cx.Nord() & c;
             p = p1 & (p_cx.Sud()
                    | (p_cx.SW() - p_cx.Ouest())
                    | (p_cx.SE() - p_cx.Est()));
   break;}
   case 1 : {p1 = p_cx.Sud() & c;
             p = p1 & (p_cx.Nord()
                    | (p_cx.NE() - p_cx.Est())
                    | (p_cx.NW() - p_cx.Ouest()));
   break;}
   }
 }


void Skiz(Image<int>& p,int n){

int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
int dir;

  dir = n % 4;
  pare_chocs4(p1,p,dir);
  if (dir == 0) p = p | (p.Est() - p1);
   else if (dir == 2) p = p | (p.Ouest() - p1);
    else if (dir == 3) p = p | (p.Nord() - p1);
     else  p = p | (p.Sud() - p1);
}


void marqhomot(Image<int>& p,Image<int> p_ancr){
int w = p.PW();
int h = p.PL();
Image<int> p1(w,h);
Image<int> p2(w,h);
Image<int> p3(w,h);
Image<int> p4(w,h);
 
int pas_fini =1;
int Nb;
int cpt =0;
 
while (pas_fini) {
 p2 = p.NW() & p.Nord();
 p1 = p.NW() | p.Nord();
 p4 = p.Ouest();p3 = p1 & p4;p2 = p3 | p2;p1 = p1 | p4;
 p4 = p.NE();p3 = p1 & p4;p2 = p3 | p2;p1 = p1 | p4;
 p4 = p.Est();p3 = p1 & p4;p2 = p3 | p2;p1 = p1 | p4;
 p4 = p.SW();p3 = p1 & p4;p2 = p3 | p2;p1 = p1 | p4;
 p4 = p.Sud();p3 = p1 & p4;p2 = p3 | p2;p1 = p1 | p4;
 p4 = p.SE();p3 = p1 & p4;p2 = p3 | p2;p1 = p1 | p4;    
 p2 = p1 & p - p2;
 p1 = p - p1;
 p4 = p;
    switch (cpt++%8){
    case 0 : {front_nord(p);break;}
    case 1 : {front_est(p);break;}
    case 2 : {front_sud(p);break;}
    case 3 : {front_ouest(p);break;}
    case 4 : {front_ouest(p);break;}
    case 5 : {front_sud(p);break;}
    case 6 : {front_est(p);break;}
    case 7 : {front_nord(p);break;}
    }
   p = p - p2;
   p2 = p2 & (p2.SW() | p2.SE() | p2.Sud() | p2.Est());
   p = p | p1 | p2;
   p = p & p4;
   p = p | p_ancr;
  if (cpt%3 == 2) {
         p4 = p4 - p;  
 Nb = p4.Image_compte_pixel();
         pas_fini = (Nb != 0);}
  }
}      
