#include "Image.hh"
#include "morfo.hh"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


int pt4int(int x,int y,Image<int>& p) {
  return (p.X(x,y) && p.X(x-1,y) && p.X(x,y-1) && p.X(x+1,y) && p.X(x,y+1));
}

int edg4(int x,int y,Image<int>& p) {
  return (p.X(x,y) && !(p.X(x-1,y) && p.X(x,y-1) && p.X(x+1,y) && p.X(x,y+1)));
}

int coin(int i,int j,Image<int>& p) {
  return (((edg4(i+1,j,p)&&edg4(i+2,j,p))&&((edg4(i,j+1,p)&&edg4(i,j+2,p)&&p.X(i+1,j+1)) ||
					    (edg4(i,j-1,p)&&edg4(i,j-2,p)&&p.X(i+1,j-1)))) ||
	  ((edg4(i-1,j,p)&&edg4(i-2,j,p))&&((edg4(i,j+1,p)&&edg4(i,j+2,p)&&p.X(i-1,j+1)) ||
					    (edg4(i,j-1,p)&&edg4(i,j-2,p)&&p.X(i-1,j-1)))) ||
	  ((edg4(i-1,j-1,p)&&edg4(i-2,j-2,p))&&((edg4(i-1,j+1,p)&&edg4(i-2,j+2,p)&&p.X(i-1,j)) ||
						(edg4(i+1,j-1,p)&&edg4(i+2,j-2,p)&&p.X(i,j-1)))) ||
	  ((edg4(i+1,j+1,p)&&edg4(i+2,j+2,p))&&((edg4(i-1,j+1,p)&&edg4(i-2,j+2,p)&&p.X(i,j+1)) ||
						(edg4(i+1,j-1,p)&&edg4(i+2,j-2,p)&&p.X(i+1,j)))));
}
  

void Calcul_coins(Image<int>& p,Image<int>& p_res) {
  int w = p.PW();
  int h = p.PL();
  int* PIX=p_res.PI();
  Image<int> q(p);
  int* Qpix=q.PI();
  int index = 0;
  int i,j;
  FIFO f(w*h);
  
  for (j=0;j<h;j++)
    for (i=0;i<w;i++){
      if (p.X(i,j) && !(p.X(i-1,j) && p.X(i+1,j) && p.X(i,j-1) && p.X(i,j+1))) {
	Qpix[index] = 255; 
	f.FIFO_add(i,j);
      } else Qpix[index] = 0;
      index++;
    }
  p_res = q;
  while (!f.FIFO_empty()) { 
    f.FIFO_get(i,j);
    if (((q.X(i+1,j)&&q.X(i+2,j))&&((q.X(i,j+1)&&q.X(i,j+2)) ||
				    (q.X(i,j-1)&&q.X(i,j-2)))) ||
	((q.X(i-1,j)&&q.X(i-2,j))&&((q.X(i,j+1)&&q.X(i,j+2)) ||
				    (q.X(i,j-1)&&q.X(i,j-2)))) ||
	((q.X(i-1,j-1)&&q.X(i-2,j-2))&&((q.X(i-1,j+1)&&q.X(i-2,j+2)) ||
					(q.X(i+1,j-1)&&q.X(i+2,j-2)))) ||
	((q.X(i+1,j+1)&&q.X(i+2,j+2))&&((q.X(i-1,j+1)&&q.X(i-2,j+2)) ||
					(q.X(i+1,j-1)&&q.X(i+2,j-2)))))  PIX[j*w+i]=255;
    else PIX[j*w+i]=0;
  }
}


int CONDITION(int x,int y,char *nom,Image<int>& p,Image<int>& q,int flagcoins) {
  int alpha,beta;
  int gamma = 0;
  
  if (flagcoins)
    gamma = coin(x,y,p);
  alpha = ((q.X(x+1,y) && !p.X(x-1,y)) || (q.X(x-1,y) && !p.X(x+1,y)) ||
	   (q.X(x,y+1) && !p.X(x,y-1)) || (q.X(x,y-1) && !p.X(x,y+1)));
  if (strcmp(nom,"mb2")==0) alpha = (alpha ||
	     (q.X(x+1,y+1) && !p.X(x-1,y) && !p.X(x,y-1)) ||
	     (q.X(x-1,y+1) && !p.X(x+1,y) && !p.X(x,y-1)) ||
	     (q.X(x+1,y-1) && !p.X(x-1,y) && !p.X(x,y+1)) ||
	     (q.X(x-1,y-1) && !p.X(x+1,y) && !p.X(x,y+1)));
  else if (strcmp(nom,"mb2min")==0) alpha = (alpha ||
           (p.X(x+1,y+1) && (p.X(x+2,y+1) && p.X(x+1,y+2)) && !p.X(x-1,y) && !p.X(x,y-1)) ||
           (p.X(x-1,y+1) && (p.X(x-2,y+1) && p.X(x-1,y+2)) && !p.X(x+1,y) && !p.X(x,y-1)) ||
           (p.X(x+1,y-1) && (p.X(x+2,y-1) && p.X(x+1,y-2)) && !p.X(x-1,y) && !p.X(x,y+1)) ||
	   (p.X(x-1,y-1) && (p.X(x-2,y-1) && p.X(x-1,y-2)) && !p.X(x+1,y) && !p.X(x,y+1)));
  beta = ((p.X(x+1,y+1) && !(p.X(x+1,y) || p.X(x,y+1))) ||
          (p.X(x+1,y-1) && !(p.X(x+1,y) || p.X(x,y-1))) ||
          (p.X(x-1,y+1) && !(p.X(x-1,y) || p.X(x,y+1))) ||
	  (p.X(x-1,y-1) && !(p.X(x-1,y) || p.X(x,y-1))));
  return (alpha && !beta && !gamma);
}

int CONDITIONbis(int x,int y,char *nom,Image<int>& p,int flagcoins) {
  int alpha,beta;
  int gamma = 0;

  if (flagcoins)
    gamma = coin(x,y,p);
  alpha = ((pt4int(x+1,y,p) && !p.X(x-1,y)) || (pt4int(x-1,y,p) && !p.X(x+1,y)) ||
	   (pt4int(x,y+1,p) && !p.X(x,y-1)) || (pt4int(x,y-1,p) && !p.X(x,y+1)));
  if (strcmp(nom,"mb2")==0) alpha = (alpha ||
	     (pt4int(x+1,y+1,p) && !p.X(x-1,y) && !p.X(x,y-1)) ||
	     (pt4int(x-1,y+1,p) && !p.X(x+1,y) && !p.X(x,y-1)) ||
	     (pt4int(x+1,y-1,p) && !p.X(x-1,y) && !p.X(x,y+1)) ||
	     (pt4int(x-1,y-1,p) && !p.X(x+1,y) && !p.X(x,y+1)));
   else if (strcmp(nom,"mb2min")==0) alpha = (alpha ||
           (p.X(x+1,y+1) && (p.X(x+2,y+1) && p.X(x+1,y+2)) && !p.X(x-1,y) && !p.X(x,y-1)) ||
           (p.X(x-1,y+1) && (p.X(x-2,y+1) && p.X(x-1,y+2)) && !p.X(x+1,y) && !p.X(x,y-1)) ||
           (p.X(x+1,y-1) && (p.X(x+2,y-1) && p.X(x+1,y-2)) && !p.X(x-1,y) && !p.X(x,y+1)) ||
	   (p.X(x-1,y-1) && (p.X(x-2,y-1) && p.X(x-1,y-2)) && !p.X(x+1,y) && !p.X(x,y+1)));
  beta = ((p.X(x+1,y+1) && !(p.X(x+1,y) || p.X(x,y+1))) ||
	  (p.X(x+1,y-1) && !(p.X(x+1,y) || p.X(x,y-1))) ||
	  (p.X(x-1,y+1) && !(p.X(x-1,y) || p.X(x,y+1))) ||
	  (p.X(x-1,y-1) && !(p.X(x-1,y) || p.X(x,y-1))));
  return (alpha && !beta && !gamma);
}


int CONDITION_DIR(int x,int y,Image<int>& p,int conex,char *nom,int dir,int flagcoins) {
  int alpha,beta;
  int gamma = 0;

  if (flagcoins)
    gamma = coin(x,y,p);
  if (conex == 8) {
    if (dir == 0) { // Itration NORD
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x,y+1) && (p.X(x-1,y+1) || p.X(x+1,y+1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x+1,y+1) && (p.X(x+1,y) || p.X(x,y+1)) && !p.X(x-1,y)) ||
		   (p.X(x-1,y+1) && (p.X(x-1,y) || p.X(x,y+1)) && !p.X(x+1,y)));
	  beta = ((p.X(x+1,y+1) && !(p.X(x+1,y) || p.X(x,y+1))) ||
		  (p.X(x+1,y-1) && !(p.X(x+1,y) || p.X(x,y-1))) ||
		  (p.X(x-1,y+1) && !(p.X(x-1,y) || p.X(x,y+1))) ||
		  (p.X(x-1,y-1) && !(p.X(x-1,y) || p.X(x,y-1))));
	} else beta = ((p.X(x-1,y-1) && !p.X(x-1,y)) || (p.X(x+1,y-1) && !p.X(x+1,y)));
      }
    } else if (dir == 1) { // Itration EST
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x-1,y) && (p.X(x-1,y-1) || p.X(x-1,y+1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x-1,y-1) && (p.X(x-1,y) || p.X(x,y-1)) && !p.X(x,y+1)) ||
		   (p.X(x-1,y+1) && (p.X(x-1,y) || p.X(x,y+1)) && !p.X(x,y-1)));
	  beta = ((p.X(x+1,y+1) && !(p.X(x+1,y) || p.X(x,y+1))) ||
		  (p.X(x+1,y-1) && !(p.X(x+1,y) || p.X(x,y-1))) ||
		  (p.X(x-1,y+1) && !(p.X(x-1,y) || p.X(x,y+1))) ||
		  (p.X(x-1,y-1) && !(p.X(x-1,y) || p.X(x,y-1))));
	} else beta = ((p.X(x+1,y-1) && !p.X(x,y-1)) || (p.X(x+1,y+1) && !p.X(x,y+1)));
      }
    } else if (dir == 2) { // Itration SUD
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x,y-1) && (p.X(x-1,y-1) || p.X(x+1,y-1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x-1,y-1) && (p.X(x-1,y) || p.X(x,y-1)) && !p.X(x+1,y)) ||
		   (p.X(x+1,y-1) && (p.X(x+1,y) || p.X(x,y-1)) && !p.X(x-1,y)));
	  beta = ((p.X(x+1,y+1) && !(p.X(x+1,y) || p.X(x,y+1))) ||
		  (p.X(x+1,y-1) && !(p.X(x+1,y) || p.X(x,y-1))) ||
		  (p.X(x-1,y+1) && !(p.X(x-1,y) || p.X(x,y+1))) ||
		  (p.X(x-1,y-1) && !(p.X(x-1,y) || p.X(x,y-1))));
	} else beta = ((p.X(x-1,y+1) && !p.X(x-1,y)) || (p.X(x+1,y+1) && !p.X(x+1,y)));
      }
    } else { // Itration OUEST
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x+1,y) && (p.X(x+1,y-1) || p.X(x+1,y+1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x+1,y+1) && (p.X(x+1,y) || p.X(x,y+1)) && !p.X(x,y-1)) ||
		   (p.X(x+1,y-1) && (p.X(x+1,y) || p.X(x,y-1)) && !p.X(x,y+1)));	
	  beta = ((p.X(x+1,y+1) && !(p.X(x+1,y) || p.X(x,y+1))) ||
		  (p.X(x+1,y-1) && !(p.X(x+1,y) || p.X(x,y-1))) ||
		  (p.X(x-1,y+1) && !(p.X(x-1,y) || p.X(x,y+1))) ||
		  (p.X(x-1,y-1) && !(p.X(x-1,y) || p.X(x,y-1))));
	} else beta = ((p.X(x-1,y-1) && !p.X(x,y-1)) || (p.X(x-1,y+1) && !p.X(x,y+1)));
      }
    }
    return (alpha && !beta && !gamma);
  } else {
    // premire version des mbdir 4-connexes...
    //     if (dir == 0) { // Itration NORD
    //       if (strncmp(nom,"mb",2)==0) {
    // 	alpha = (p.X(x-1,y+1) && p.X(x,y+1) && p.X(x+1,y+1));
    // 	if (strcmp(nom,"mb2")==0) alpha = (alpha ||
    // 		     (p.X(x+1,y+1) && p.X(x+1,y) && p.X(x,y+1) && !p.X(x-1,y)) ||
    // 		     (p.X(x-1,y+1) && p.X(x-1,y) && p.X(x,y+1) && !p.X(x+1,y)));				
    //       }
    //     } else if (dir == 1) { // Itration EST
    //       if (strncmp(nom,"mb",2)==0) {
    // 	alpha = (p.X(x-1,y-1) && p.X(x-1,y) && p.X(x-1,y+1));
    // 	if (strcmp(nom,"mb2")==0) alpha = (alpha ||
    // 		     (p.X(x-1,y-1) && p.X(x-1,y) && p.X(x,y-1) && !p.X(x,y+1)) ||
    // 		     (p.X(x-1,y+1) && p.X(x-1,y) && p.X(x,y+1) && !p.X(x,y-1)));	
    //       }
    //     } else if (dir == 2) { // Itration SUD
    //       if (strncmp(nom,"mb",2)==0) {
    // 	alpha = (p.X(x-1,y-1) && p.X(x,y-1) && p.X(x+1,y-1));
    // 	if (strcmp(nom,"mb2")==0) alpha = (alpha ||
    // 		     (p.X(x-1,y-1) && p.X(x-1,y) && p.X(x,y-1) && !p.X(x+1,y)) ||
    // 	             (p.X(x+1,y-1) && p.X(x+1,y) && p.X(x,y-1) && !p.X(x-1,y)));	
    //       }
    //     } else { // Itration OUEST
    //       if (strncmp(nom,"mb",2)==0) {
    // 	alpha = (p.X(x+1,y-1) && p.X(x+1,y) && p.X(x+1,y+1));
    // 	if (strcmp(nom,"mb2")==0) alpha = (alpha ||
    // 		     (p.X(x+1,y+1) && p.X(x+1,y) && p.X(x,y+1) && !p.X(x,y-1)) ||
    //                      (p.X(x+1,y-1) && p.X(x+1,y) && p.X(x,y-1) && !p.X(x,y+1)));	
    //       }
    //     }
    //     return (alpha && !gamma);
    //   }
    // Nouvelle version des mbdir 4-connexes...
    if (dir == 0) { // Itration NORD
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x,y+1) && (p.X(x-1,y+1) || p.X(x+1,y+1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x+1,y+1) && (p.X(x+1,y) || p.X(x,y+1)) && !p.X(x-1,y)) ||
		   (p.X(x-1,y+1) && (p.X(x-1,y) || p.X(x,y+1)) && !p.X(x+1,y)));
	} beta = (!p.X(x-1,y+1)&&p.X(x-1,y)) || (!p.X(x+1,y+1)&&p.X(x+1,y));
      }
    } else if (dir == 1) { // Itration EST
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x-1,y) && (p.X(x-1,y-1) || p.X(x-1,y+1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x-1,y-1) && (p.X(x-1,y) || p.X(x,y-1)) && !p.X(x,y+1)) ||
		   (p.X(x-1,y+1) && (p.X(x-1,y) || p.X(x,y+1)) && !p.X(x,y-1)));
	} beta = (!p.X(x-1,y-1)&&p.X(x,y-1)) || (!p.X(x-1,y+1)&&p.X(x,y+1));
      }
    } else if (dir == 2) { // Itration SUD
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x,y-1) && (p.X(x-1,y-1) || p.X(x+1,y-1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x-1,y-1) && (p.X(x-1,y) || p.X(x,y-1)) && !p.X(x+1,y)) ||
		   (p.X(x+1,y-1) && (p.X(x+1,y) || p.X(x,y-1)) && !p.X(x-1,y)));
	} beta = (!p.X(x-1,y-1)&&p.X(x-1,y)) || (!p.X(x+1,y-1)&&p.X(x+1,y));
      }
    } else { // Itration OUEST
      if (strncmp(nom,"mb",2)==0) {
	alpha = (p.X(x+1,y) && (p.X(x+1,y-1) || p.X(x+1,y+1)));
	if (strcmp(nom,"mb2")==0) {
	  alpha = (alpha ||
		   (p.X(x+1,y+1) && (p.X(x+1,y) || p.X(x,y+1)) && !p.X(x,y-1)) ||
		   (p.X(x+1,y-1) && (p.X(x+1,y) || p.X(x,y-1)) && !p.X(x,y+1)));	
	} beta = (!p.X(x+1,y-1)&&p.X(x,y-1)) || (!p.X(x+1,y+1)&&p.X(x,y+1));
      }
    }
    return (alpha && !beta && !gamma);
  }
}


void Squelette(Image<int>& p,char *algo,int flagcoins){
 
int w = p.PW();
int h = p.PL();
Image<int> q(p);
Image<int> qtemp(p);
Image<int> ptemp(p);
int* Qpix=qtemp.PI();
int* Ppix=ptemp.PI();
int index,x,y;
FIFO f(w*h);
FIFO g(w*h);
 
 for (int j=0;j<h;j++)
   for (int i=0;i<w;i++){
     index = j*w + i;
     if (p.X(i,j) && !(p.X(i-1,j)&&p.X(i+1,j)&&p.X(i,j-1)&&p.X(i,j+1))) {f.FIFO_add(i,j); Qpix[index]=0;}
   }

 while (!f.FIFO_empty()) { 
   q = qtemp;
   while (!f.FIFO_empty()) {
     f.FIFO_get(x,y);
     if (qtemp.X(x-1,y)) {g.FIFO_add(x-1,y);Qpix[y*w+x-1]=0;}
     if (qtemp.X(x+1,y)) {g.FIFO_add(x+1,y);Qpix[y*w+x+1]=0;}
     if (qtemp.X(x,y-1)) {g.FIFO_add(x,y-1);Qpix[(y-1)*w+x]=0;}
     if (qtemp.X(x,y+1)) {g.FIFO_add(x,y+1);Qpix[(y+1)*w+x]=0;}
     if (CONDITION(x,y,algo,p,q,flagcoins)) Ppix[y*w+x]=0;
   }
   f = g;
   g.FIFO_delete();
   p = ptemp;
 }
}

//La procdure qui suit est pour l'instant inoprante
void Squelet_dir(Image<int>& p,char *algo,int flagcoins){
 
int w = p.PW();
int h = p.PL();
Image<int> q(p);
Image<int> qtemp(p);
Image<int> ptemp(p);
int* Qpix=qtemp.PI();
int* Ppix=ptemp.PI();
int index,x,y;
FIFO f(w*h);
FIFO g(w*h);
 
 for (int j=0;j<h;j++)
   for (int i=0;i<w;i++){
     index = j*w + i;
     if (p.X(i,j) && !(p.X(i-1,j)&&p.X(i+1,j)&&p.X(i,j-1)&&p.X(i,j+1)&&p.X(i-1,j-1)&&p.X(i-1,j+1)&&p.X(i-1,j-1))) {f.FIFO_add(i,j); Qpix[index]=0;}
   }

 while (!f.FIFO_empty()) { 
   q = qtemp;
   while (!f.FIFO_empty()) {
     f.FIFO_get(x,y);
     if (qtemp.X(x-1,y)) {g.FIFO_add(x-1,y);Qpix[y*w+x-1]=0;}
     if (qtemp.X(x+1,y)) {g.FIFO_add(x+1,y);Qpix[y*w+x+1]=0;}
     if (qtemp.X(x,y-1)) {g.FIFO_add(x,y-1);Qpix[(y-1)*w+x]=0;}
     if (qtemp.X(x,y+1)) {g.FIFO_add(x,y+1);Qpix[(y+1)*w+x]=0;}
     if (CONDITION(x,y,algo,p,q,flagcoins)) Ppix[y*w+x]=0;
   }
   f = g;
   g.FIFO_delete();
   p = ptemp;
 }
}

// La procdure qui suit n'est plus utilise.
void Squeldist(Image<int>& p,char *algo,char *dist,int flagcoins) {
 
int w = p.PW();
int h = p.PL();
int i,j,valmax=0,x,y;
int distmax = 0;
int *tabdist;
Image<int> pdist(p);
Image<int> ptemp(p);
Image<int> q(p);
int *DIST = pdist.PI();
int* Qpix=q.PI();
int* Ppix=ptemp.PI();
FIFO f(w*h);
FIFO g(w*h); 
FIFO sk(w*h);
 
   // Calcul de la fonction distance
 for (j=0;j<h;j++)
   for (i=0;i<w;i++)
     if (pdist.X(i,j) > 0) DIST[j*w+i] = PutDistance(pdist,i,j,dist,1);
 for (j=h-1;j>=0;j--)
   for (i=w-1;i>=0;i--)
     if (pdist.X(i,j) > 0) {
       DIST[j*w+i] =  PutDistance(pdist,i,j,dist,-1);
       if (DIST[j*w+i] > valmax) valmax = DIST[j*w+i];
     }
 // Cration de la liste initiale
 tabdist = new int[valmax+1];
 for (i=1;i<=valmax;i++) tabdist[i]=0;
 for (j=0;j<h;j++)
   for (i=0;i<w;i++)
     if (pdist.X(i,j)) {tabdist[pdist.X(i,j)]++;f.FIFO_add(i,j);}
 // Squelettisation
 for (i=1;i<=valmax;i++) {
   if (tabdist[i]) {
     while (!f.FIFO_empty()) { 
       f.FIFO_get(x,y);
       if (!(p.X(x-1,y)&&p.X(x+1,y)&&p.X(x,y-1)&&p.X(x,y+1))) Qpix[y*w+x]=0;
       if (pdist.X(x,y)==i) 
	 sk.FIFO_add(x,y);
       else g.FIFO_add(x,y);
     }
     f = g;
     g.FIFO_delete();
     while (!sk.FIFO_empty()) { 
       sk.FIFO_get(x,y);
       if (CONDITION(x,y,algo,p,q,flagcoins)) Ppix[y*w+x]=0;
     }
     p = ptemp;
   }
 }
  delete[] tabdist;
}

void Squeldistance(Image<int>& p,char *algo,char *dist,int flagcoins) {
 
int w = p.PW();
int h = p.PL();
int i,j,valmax=0,x,y;
int distmax = 0;
int *tabdist;
Image<int> pdist(p);
Image<int> ptemp(p);
int *DIST = pdist.PI();
int* Ppix=ptemp.PI();
FIFO f(w*h);
FIFO *listes;
 
   // Calcul de la fonction distance
 for (j=0;j<h;j++)
   for (i=0;i<w;i++)
     if (pdist.X(i,j) > 0) DIST[j*w+i] = PutDistance(pdist,i,j,dist,1);
 for (j=h-1;j>=0;j--)
   for (i=w-1;i>=0;i--)
     if (pdist.X(i,j) > 0) {
       DIST[j*w+i] =  PutDistance(pdist,i,j,dist,-1);
       if (DIST[j*w+i] > valmax) valmax = DIST[j*w+i];
     }
 // Cration de la liste initiale
 tabdist = new int[valmax+1];
 for (i=1;i<=valmax;i++) tabdist[i]=0;
 for (j=0;j<h;j++)
   for (i=0;i<w;i++)
     if (pdist.X(i,j)) {tabdist[pdist.X(i,j)]++;f.FIFO_add(i,j);}
 listes = new FIFO[valmax+1];
 for (i=1;i<=valmax;i++) listes[i].FIFO_alloc(tabdist[i]+1);
 while (!f.FIFO_empty()) { 
   f.FIFO_get(x,y);
   listes[pdist.X(x,y)].FIFO_add(x,y);
 }
 // Squelettisation...
 for (i=1;i<=valmax;i++) {
   if (tabdist[i]) {
     // printf("distance %d : %d\n",i,tabdist[i]);
     while (!listes[i].FIFO_empty()) { 
       listes[i].FIFO_get(x,y);
       if (CONDITIONbis(x,y,algo,p,flagcoins)) Ppix[y*w+x]=0;
     }
     p = ptemp;
   }
 }
 for (i=1;i<=valmax;i++) listes[i].FIFO_free();
 //delete[] listes;
 delete[] tabdist;
}

void Squeldist_dir(Image<int>& p,char *algo,char *dist,int con,int flagcoins) {
 
int w = p.PW();
int h = p.PL();
int i,j,valmax=0,x,y;
int distmax = 0;
int *tabdist;
Image<int> pdist(p);
Image<int> ptemp(p);
int *DIST = pdist.PI();
int* Ppix=ptemp.PI();
FIFO f(w*h);
FIFO gtemp(w*h);
FIFO *listes;
 
   // Calcul de la fonction distance
 for (j=0;j<h;j++)
   for (i=0;i<w;i++)

     if (pdist.X(i,j) > 0) DIST[j*w+i] = PutDistance(pdist,i,j,dist,1);
 for (j=h-1;j>=0;j--)
   for (i=w-1;i>=0;i--)
     if (pdist.X(i,j) > 0) {
       DIST[j*w+i] =  PutDistance(pdist,i,j,dist,-1);
       if (DIST[j*w+i] > valmax) valmax = DIST[j*w+i];
     }
 // Cration de la liste initiale
 tabdist = new int[valmax+1];
 for (i=1;i<=valmax;i++) tabdist[i]=0;
 for (j=0;j<h;j++)
   for (i=0;i<w;i++)
     if (pdist.X(i,j)) {tabdist[pdist.X(i,j)]++;f.FIFO_add(i,j);}
 listes = new FIFO[valmax+1];
 for (i=1;i<=valmax;i++) listes[i].FIFO_alloc(tabdist[i]);
 while (!f.FIFO_empty()) { 
   f.FIFO_get(x,y);
   listes[pdist.X(x,y)].FIFO_add(x,y);
 }
 // Squelettisation...
 for (i=1;i<=valmax;i++) {
   if (tabdist[i]) {
     //printf("distance %d : %d\n",i,tabdist[i]);
     // Itration NORD
     while (!listes[i].FIFO_empty()) { 
       listes[i].FIFO_get(x,y);
       if (!p.X(x,y-1)) {
	 if (CONDITION_DIR(x,y,p,con,algo,0,flagcoins)) Ppix[y*w+x]=0;
       } else gtemp.FIFO_add(x,y);
     } 
     listes[i] = gtemp;
     gtemp.FIFO_delete(); 
     p = ptemp;
     // Itration EST
     while (!listes[i].FIFO_empty()) { 
       listes[i].FIFO_get(x,y);
       if (!p.X(x+1,y)) {
	 if (CONDITION_DIR(x,y,p,con,algo,1,flagcoins)) Ppix[y*w+x]=0;
       } else gtemp.FIFO_add(x,y);
     }
     listes[i] = gtemp;
     gtemp.FIFO_delete(); 
     p = ptemp;
     // Itration SUD
     while (!listes[i].FIFO_empty()) { 
       listes[i].FIFO_get(x,y);
       if (!p.X(x,y+1)) {
	 if (CONDITION_DIR(x,y,p,con,algo,2,flagcoins)) Ppix[y*w+x]=0;
       } else gtemp.FIFO_add(x,y);
     }
     listes[i] = gtemp;
     gtemp.FIFO_delete(); 
     p = ptemp;
     // Itration OUEST
     while (!listes[i].FIFO_empty()) { 
       listes[i].FIFO_get(x,y);
       if (!p.X(x-1,y)) {
	 if (CONDITION_DIR(x,y,p,con,algo,3,flagcoins)) Ppix[y*w+x]=0;
       } else gtemp.FIFO_add(x,y);
     }
     listes[i] = gtemp;
     gtemp.FIFO_delete(); 
     p = ptemp;
   }
 }
 //for (i=1;i<=valmax;i++) listes[i].FIFO_free();
 //delete[] listes;
 delete[] tabdist;
}

void mb_direction(Image<int>& p,char *algo,int conex,int num,int flag_coins){
  int w = p.PW();
  int h = p.PL();
  Image<int> pp(p);
  Image<int> q(p);
  int index=0; 
  int* pix=p.PI();
  
  //  if (flag_coins) 
//      Calcul_coins(p,q);
  if (num%4 == 0) {
    // Itration NORD
    for (int y=0;y<h;y++)
      for (int x=0;x<w;x++){
	//if (pp.X(x,y) && !(pp.X(x,y-1)) && !(flag_coins && q.X(x,y))) {
	if (pp.X(x,y) && !pp.X(x,y-1)) {
	  if (CONDITION_DIR(x,y,pp,conex,algo,0,flag_coins)) pix[index]=0;
	}
	index++;
      }
  } else if (num%4 == 1) {
    // Itration EST
    for (int y=0;y<h;y++)
      for (int x=0;x<w;x++){
	// if (pp.X(x,y) && !(pp.X(x+1,y)) && !(flag_coins && q.X(x,y))) {
	if (pp.X(x,y) && !pp.X(x+1,y)) {
	  if (CONDITION_DIR(x,y,pp,conex,algo,1,flag_coins)) pix[index]=0; 
	}
	index++;
      }
  } else if (num%4 == 2) {
    // Itration SUD
    for (int y=0;y<h;y++)
      for (int x=0;x<w;x++){
	//if (pp.X(x,y) && !(pp.X(x,y+1)) && !(flag_coins && q.X(x,y))) {
	if (pp.X(x,y) && !pp.X(x,y+1)) {
	  if (CONDITION_DIR(x,y,pp,conex,algo,2,flag_coins)) pix[index]=0;
	}
	index++;
      }
  } else {
    // Itration OUEST
    for (int y=0;y<h;y++)
      for (int x=0;x<w;x++){
	//if (pp.X(x,y) && !(pp.X(x-1,y)) && !(flag_coins && q.X(x,y))) {
	if (pp.X(x,y) && !pp.X(x-1,y)) {
	  if (CONDITION_DIR(x,y,pp,conex,algo,3,flag_coins)) pix[index]=0;
	}
	index++;
      }
  }
}  

void mb_fullpar(Image<int>& p,char *algo,int flag_coins) {
  int w = p.PW();
  int h = p.PL();
  Image<int> pp(p);
  Image<int> q(p);
  //int alea;
  int index=0; 
  int* pix=p.PI();
  
  if (flag_coins) 
    Calcul_coins(p,q);
  for (int y=0;y<h;y++)
    for (int x=0;x<w;x++){
      if (pp.X(x,y) && !(flag_coins && q.X(x,y))) {
	//alea = rand();
	//if ((CONDITIONbis(x,y,algo,pp,0)) && (alea > RAND_MAX/20)) pix[index]=0;
	if (CONDITIONbis(x,y,algo,pp,0)) pix[index]=0;
      }
      index++;
    }
} 
